SuperStrict
	
AppTitle = "BCC#63 - PacOut"
Global gfx_w:Int = 800
Global gfx_h:Int = 400
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(60)

SetColor(255, 255, 255)
SetClsColor(0, 0, 0)
SetBlend(ALPHABLEND)
MoveMouse(gfx_w *.5, gfx_h *.5)

Global Tiles:Int = 10, TileSize:Int = 24
Global Map:Int[Tiles, Tiles]
FillMap()

Global Player_x:Int = gfx_w *.5, Player_y:Int = gfx_h *.9
Global Points:Long
Global Ball_x:Float = Player_x, Ball_y:Float = Player_y
Global Ball_Sx:Float = Rnd(-2, 2), Ball_Sy:Float = -2

Repeat
	Cls
	
	SetColor(255, 255, 255)
	Local refill:Int = True
	For Local y:Int = 0 Until Tiles
		For Local x:Int = 0 Until Tiles
			If Map[x, y] Then
				refill = False
				Local posX:Int = 48 + x * TileSize * 4
				Local posY:Int = 48 + y * TileSize
				Drawkreis(posX, posY, TileSize *.75)
				If Distanz(posX, posY, Ball_x, Ball_y) < TileSize *.75 Then
					Map[x, y] = 0
					If Map[x, y] = 0 Then Points:+10000
				EndIf
			EndIf
		Next
	Next
	
	If refill Then
		FillMap()
	EndIf
	
	DrawText("Punkte: " + Points, gfx_w *.4, gfx_h *.05)
	
	
	DrawRect(Player_x, Player_y, 64, 4)
	If KeyDown(KEY_LEFT) Then Player_x:-5
	If KeyDown(KEY_RIGHT) Then Player_x:+5
	
	DrawPac()
	Ball_x:+Ball_Sx
	Ball_y:+Ball_Sy
	
	If PacInRect(Player_x, Player_y, 64, 4) Then
		Ball_Sx:+Rnd(-0.3, 0.6)
		Ball_Sy = -Ball_Sy * 1.1
	EndIf
	
	If Ball_x < 0 Then Ball_x = 0 ;Ball_Sx = -Ball_Sx
	If Ball_x > gfx_w Then Ball_x = gfx_w ;Ball_Sx = -Ball_Sx
	
	If Ball_y < 0 Then Ball_y = 0 ;Ball_Sy = -Ball_Sy
	If Ball_y > gfx_h Then
		Cls
		SetColor(255, 255, 255)
		DrawText("GAME OVER", gfx_w *.5, gfx_h *.5)
		DrawText(Points, gfx_w *.5, gfx_h *.4)
		Flip
		WaitKey()
		End
	EndIf

	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Function Drawkreis(x:Float, y:Float, r:Float)
	DrawOval(x - r *.5, y - r *.5, r, r)
End Function

Function Distanz:Float(sx:Float, sy:Float, zx:Float, zy:Float)
	Return Sqr(((zx - sx) ^ 2) + ((zy - sy) ^ 2))
End Function

Function FillMap()
	For Local y:Int = 0 Until Tiles
		For Local x:Int = 0 Until Tiles
			Map[x, y] = True
		Next
	Next	
End Function

Function DrawPac()

	SetColor(255, 255, 0)
	Drawkreis(Ball_x, Ball_y, 24)
	
	Local dx:Int = Ball_x + Ball_Sx * 3
	Local dy:Int = Ball_y + Ball_Sy * 3
	
	Local r:Float = Sin(MilliSecs() Mod 1000) * 18
	
	SetColor(0, 0, 0)
	Drawkreis(dx, dy, r)

End Function

Function PacInRect:Int(x:Int, y:Int, w:Int, h:Int)
	If Ball_x <= x Then Return False
	If Ball_y <= y Then Return False
	If Ball_x >= x + w Then Return False
	If Ball_y >= y + h Then Return False
	Return True	
End Function